function [xhat] = SIR(y,a,c,like,Rww,P0,N,Nsamps)
%::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
% SAMPLIMG/IMPORTANCE RE-SAMPLING (SIR) ALGORITHM---Bootstrap Estimator
%::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

x = sqrt(P0)*randn(1,N);                    % STEP 1, Initialize the particles

% time loop

for t = 1:Nsamps
    e = repmat(y(t),1,N) -c(x);             % STEP 2, Calculate weights
    W = feval(like,e);                      % The likelihood function UPDATE
    W = W/sum(W);                           % Normalize the importance weights
    ind = resampling(W);                    % STEP 3, resample (systematic)
    x = x(:,ind);                           % The new particles
    xhat(t) = mean(x);                      % Compute the estimate --- conditional mean
    x = feval(a,x,t)+sqrt(Rww)*randn(1,N);  % STEP 4, Time prediction
end
